; Assembled with JWasm v1.95pre, Jan 23 2009

.386
.model flat,stdcall
option casemap:none

include	\masm32\include\windows.inc
include 	\masm32\include\kernel32.inc
include 	\masm32\include\user32.inc
include 	\masm32\include\gdi32.inc

includelib	\masm32\lib\kernel32.lib
includelib	\masm32\lib\user32.lib
includelib	\masm32\lib\gdi32.lib

DlgProc PROTO :DWORD,:DWORD,:DWORD,:DWORD

IDM_ABOUT       equ 11
IDM_EXIT        equ 12
IDC_ABOUT       equ 110
IDC_EXIT        equ 120
IDC_EDIT        equ 3000

EMPTY_RSRC_SECT equ 32
RSRC_ENTRY      equ 32
RSRC_OFFSET     equ EMPTY_RSRC_SECT+RSRC_ENTRY

.data

Dlgbox  LABEL byte
INCBIN  "Dlgbox.res",RSRC_OFFSET

Menu    LABEL byte
INCBIN  "Menu.res",RSRC_OFFSET

msg     db 'Binary resource template demo',0
title1  db 'About',0

.data?

hBrush  dd ?

.code

start:

    invoke  GetModuleHandle,NULL
    invoke  DialogBoxIndirectParam,eax,ADDR Dlgbox,NULL,ADDR DlgProc,NULL
    invoke  ExitProcess,eax

DlgProc PROC hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
    
    .IF uMsg==WM_INITDIALOG
        invoke  LoadIcon,NULL,IDI_APPLICATION    
        invoke  SendMessage,hWnd,WM_SETICON,ICON_SMALL,eax
        invoke  LoadMenuIndirect,OFFSET Menu
        invoke  SetMenu,hWnd,eax
        
    .ELSEIF uMsg==WM_CTLCOLORDLG
        invoke  CreateSolidBrush,Blue
        mov     hBrush,eax
        ret

    .ELSEIF uMsg==WM_CLOSE
        invoke  SendMessage,hWnd,WM_COMMAND,IDM_EXIT,0

    .ELSEIF uMsg==WM_COMMAND
        
        mov     eax,wParam
        .IF lParam==0
            .IF ax==IDM_ABOUT
                invoke  MessageBox,NULL,ADDR msg,ADDR title1,MB_OK
                        
            .ELSEIF ax==IDM_EXIT
                mov     eax,hWnd
                call    TerminateDlg
                
            .ENDIF
        .ELSE
            mov edx,wParam
            shr edx,16
            .IF dx==BN_CLICKED
                                
                .IF ax==IDC_ABOUT
                    invoke SendMessage,hWnd,WM_COMMAND,IDM_ABOUT,0
                            
                .ELSEIF ax==IDC_EXIT
                    mov     eax,hWnd
                    call    TerminateDlg

                .ENDIF
            .ENDIF
        .ENDIF
    .ELSE
        mov eax,FALSE
        ret
    .ENDIF
    mov eax,TRUE
    ret
    
DlgProc ENDP

TerminateDlg PROC

    invoke  EndDialog,eax,NULL
    invoke  DeleteObject,hBrush
    ret

TerminateDlg ENDP

END start

